use 5.010;

my $n=500;   # vertices

open(LOG,">log.txt");
open(TAB,">log.tab");

for(my $dens=0.009;$dens<=0.011;$dens=$dens+0.00001)    # densities
	{
# generate graph on m vertices
	open(GRAPH,">xxx.graph");
	for(my $i=1;$i<=$n;$i++) { for(my $j=$i+1;$j<=$n;$j++)
		{
			my $x=rand(1);
			if ($x<$dens) { say GRAPH "$i $j"; };
		}}

	close GRAPH;
	
# run coloring
	`translator.py 3 xxx.graph >xxx.sat`;
	`minisat.exe xxx.sat xxx.out >xxx.stat`;
	
# read output, write log
	say LOG "density = $dens";
	open(OUT,"xxx.stat") or die "MiniSat did not produce any stats.\n";
	while (<OUT>)
	  {
		my $x=$_;
		if ($x =~ /CPU time/) { $x=~/(.*):([^s]*)/; $x=$2; say LOG "$x s"; say TAB "$x";  if ($x>20) {die "Graph found!";}; };
	  };
	close OUT;
	open(OUT,"xxx.out") or die "MiniSat did not produce any output.\n";
	my $x=<OUT>;
	say LOG $x;
	close OUT;
	}
	
close LOG;
close TAB;

