#!/usr/bin/python3
# translate k-coloring problem to SAT

import logging
import sys
logging.basicConfig(level=logging.DEBUG, format=' %(asctime)s - %(levelname)s - %(message)s')
logging.disable(logging.CRITICAL)

#read input 
k = int(sys.argv[1])
graphFile = sys.argv[2]
verticesCount = 0
edgesCount = 0
edges = []

#read graph
graph = open(graphFile,'r')
for line in graph:
    #counting vertices
    a,b = line.split() 
    if (int(a)>verticesCount):
        verticesCount=int(a)
    if (int(b)>verticesCount):
        verticesCount=int(b)
    #counting edges
    edgesCount +=1
    #save edge
    edges.append((int(a)-1,int(b)-1))
graph.close()

#make header
print("c A {0}-coloring of graph in {1}".format(k,graphFile))
#compute clauses
clauses = verticesCount*(1+k*(k-1)/2)+edgesCount*k
print("p cnf {0} {1}".format(k*verticesCount,int(clauses)))

#each vertex has at least one colour
logging.debug("at least one")
for i in range(0,verticesCount):
    temp = []
    for j in range(0,k):
        temp.append(str(i*k+j+1))
    temp.append(str(0))
    print(" ".join(temp))

#no vertex has two colours
logging.debug("at most one")
for v in range(0,verticesCount):
    for i in range(0,k):
        for j in range(0,i):
            print("-{0} -{1} 0".format(v*k+i+1,v*k+j+1))

#for each edge it holds that vertices are coloured differently
logging.debug("edges")
for edge in edges:
    for i in range(0,k):
        logging.debug("{0} {1}".format(edge[0],edge[1]))
        print("-{0} -{1} 0".format(edge[0]*k+i+1,edge[1]*k+i+1))

